import 'package:dio/dio.dart';
import 'dart:async';
import 'dart:convert';

class NetWorkSuccess {
  NetWorkSuccess({this.data});
  final Map data;
  Map get dataMap{
    if (this.data.runtimeType == Map) {
      return data;
    }else return null;
  }
}

class NetWorkError {
  NetWorkError({this.error});
  final Map error;
  int get errorCode{
    if (this.error.runtimeType == Map) {
      return error['errorCode'];
    }else return null;
  }
}

class ALURL {
  ALURL({this.host}) : assert(host != null);
  final String host;
  static final baseUrl = 'http://earth.igengmei.com';
  String get originUrl => (baseUrl + host);
}

class ALNetWorkHeader {

  Map<String, dynamic> get header{
    return {
      'Host':	'earth.igengmei.com',
      'Accept':	'*/*',
      'Cookie':	'_gm_token=fb20fe1550833249; sessionid=qntnckxv4n4nzrl49jmaesc5ylru92yt; _gtid=ae355f92310911e9905700163e0a7a995288',
      'User-Agent':	'GMAlpha/1.3.0 (iPhone; iOS 12.1.2; Scale/2.00)',
      'Accept-Language':	'en-CN;q=1, zh-Hans-CN;q=0.9',
      'Accept-Encoding':	'gzip, deflate',
      'Connection':	'keep-alive'
    };
  }

  Map<String, dynamic> get params {
    return {
      'platform': 'iPhone',
      'os_version':'12.1.2',
      'version':'1.3.0',
      'model':'iPhone%206s',
      'release':'0',
      'idfa':'119A3567-6C81-40EA-A3ED-A63F7DCAD86B',
      'idfv':'78BE2D94-7252-4C18-A816-2CEE6350B076',
      'device_id':'119A3567-6C81-40EA-A3ED-A63F7DCAD86B',
      'channel':'App%20Store',
      'app_name':'gengmeiios',
      'current_city_id':'worldwide',
      'lat':'0',
      'lng':'0',
      'is_WiFi':'(null)',
      'phone_id':'iPhone8'
    };
  }
}

// 管理任务
class ALNetWorkTask {
  ALNetWorkTask({this.success, this.error, this.url, this.serviceInstance});
  final NetWorkSuccessCallback success;
  final ALURL url;
  final NetWorkErrorCallback error;
  final Dio serviceInstance;

  void cancle() {
  }
}

typedef NetWorkSuccessCallback = void Function(NetWorkSuccess success);
typedef NetWorkErrorCallback = void Function(NetWorkError error);
typedef ProgressCallback = void Function(int count, int total);

class ALNetWork {
  //static 修饰的变量，为类变量，通过类对象访问
  // static final shareInstance = new ALNetWork();
  //任务映射表
  static Map<String, ALNetWorkTask> taskMap = {};

  const ALNetWork(
    {this.success,
      this.error,
      this.progress,
      this.host,
      this.params}) : assert(host != null);

  final NetWorkSuccessCallback success;
  final NetWorkErrorCallback error;
  final ProgressCallback progress;
  final String host;
  final Map params;
  ALURL get url => ALURL(host: this.host);

  Future<void> post() async{
    Response response;
    Dio dio = new Dio();
    dio.options.connectTimeout = 5000; //5s
    dio.options.receiveTimeout = 5000;
    dio.options.headers = {'user-agent': 'dio', 'common-header': 'xx'};
    response = await dio.post(this.url.originUrl, data: this.params);
    _handleNetWorkService(response);
  }

  Future<void> excuteGet() async{
    Response response;
    Dio dio = new Dio();
    dio.options.headers = ALNetWorkHeader().header;
    response = await dio.get(this.url.originUrl, queryParameters: ALNetWorkHeader().params);
    _handleNetWorkService(response);
  }

  void _handleNetWorkService(Response response) {
    var data = jsonDecode(response.toString());
    if(response.statusCode == 200){
      this.success(NetWorkSuccess(data: data));
    }else{
      this.error(NetWorkError(error: data));
    }
  }

  void upload(args) {
    
  }

  void download(args) {
    
  }
}